# React DataGrid 

## Documentation

Getting Started Guide:
https://reactdatagrid.com/docs/intro
## Install

```bash
npm install @ezgrid/grid-core @ezgrid/grid-react @ezgrid/grid-export
```
## Information


- [ReactDataGrid](https://reactdatagrid.com) is a React component for displaying tabular data, built from the ground up for 2023, by a team with [20+ years](https://reactdatagrid.com/docs/welcome#a-trip-down-the-memory-lane) of experience building datagrids.
- It integrates deeply with [Material UI](https://reactdatagrid.com/docs/welcome#material-ui-and-others), but thanks to its highly customizable rendering engine, it can be used with any UI framework, or without any UI framework at all. If you are already using Material UI, this datagrid will seamlessly integrate with your application in terms of user experience, theming, and customization.
- It is very [light weight](https://reactdatagrid.com/docs/welcome#bundle-size)  without compromising on features, thanks to a combination of [thoughtful design](https://reactdatagrid.com/docs/welcome#features),  [modern tooling & ecosystem](https://reactdatagrid.com/docs/welcome#evolution-of-webpack-tree-shaking-and-es6-modules), [plugin architecture](https://reactdatagrid.com/docs/welcome#pluggability-over-configuration), and [ES6 modules](https://reactdatagrid.com/docs/welcome#evolution-of-webpack-tree-shaking-and-es6-modules). More on this below.
- Built in React for React, with TypeScript.



## What is ezgrid ReactDataGrid?

ezgrid (Enterprise User eXperience Data Toolkit) is a toolkit for visualizing data in enterprise applications. The primary component in this library is a ReactDataGrid that can be used to display data in a tabular or hierarchical format.