'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('react/jsx-runtime');
var gridCore = require('@ezgrid/grid-core');
var freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');
var react = require('react');
var Button = require('react-bootstrap/Button');
var Form = require('react-bootstrap/Form');
var ListGroup = require('react-bootstrap/ListGroup');
var reactFontawesome = require('@fortawesome/react-fontawesome');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var Button__default = /*#__PURE__*/_interopDefaultLegacy(Button);
var Form__default = /*#__PURE__*/_interopDefaultLegacy(Form);
var ListGroup__default = /*#__PURE__*/_interopDefaultLegacy(ListGroup);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

const generateIcon = (icon, {
  onClick,
  disabled,
  title,
  className,
  style
}, textAndIcon) => textAndIcon ? jsxRuntime.jsxs(Button__default["default"], Object.assign({
  color: "primary",
  onClick: onClick,
  disabled: disabled,
  title: title,
  style: style,
  variant: "outlined"
}, {
  children: [icon, "  ", title]
}), className) : jsxRuntime.jsx(Button__default["default"], Object.assign({
  color: "primary",
  onClick: onClick,
  disabled: disabled,
  title: title,
  style: style
}, {
  children: icon
}), className);
const bootstrapAdapter = {
  createElementFromNode: (node, props, children) => {
    let propsToApply = props;
    if (node.key.indexOf("remove-circle-icon") >= 0) {
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faMinus
      }), props);
    } else if (node.key.indexOf("add-circle-icon") >= 0) {
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faPlus
      }), props);
    } else if (node.key.indexOf("expand-one-icon") >= 0) {
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faExpand
      }), props);
    } else if (node.key.indexOf("collapse-one-icon") >= 0) {
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faExpandAlt
      }), props);
    }
    return /*#__PURE__*/react.createElement("div", propsToApply, children);
  },
  createSelectField: props => {
    const {
      onChange,
      ref,
      style,
      options,
      value,
      fullWidth
    } = props;
    if ((options === null || options === void 0 ? void 0 : options.length) === 0) return null;
    return jsxRuntime.jsx(Form__default["default"].Select, Object.assign({
      onChange: e => {
        onChange === null || onChange === void 0 ? void 0 : onChange(e.target.value);
      },
      style: style,
      ref: ref,
      value: value
    }, {
      children: (options || []).map(option => jsxRuntime.jsx("option", Object.assign({
        value: option.value
      }, {
        children: option.name
      }), option.value))
    }));
  },
  createDateField: props => {
    const {
      onChange,
      value
    } = props;
    return jsxRuntime.jsx(Form__default["default"].Control, {
      type: "date",
      value: value === null || value === void 0 ? void 0 : value.toString().substring(0, 10),
      onChange: e => {
        onChange === null || onChange === void 0 ? void 0 : onChange(new Date(e.target.value));
      }
    });
  },
  createTextField: props => {
    const {
        onChange,
        attributes,
        ref
      } = props,
      rest = __rest(props, ["onChange", "attributes", "ref"]);
    return jsxRuntime.jsx(Form__default["default"].Control, Object.assign({
      onChange: e => {
        onChange === null || onChange === void 0 ? void 0 : onChange(e.target.value);
      }
    }, attributes, rest, {
      ref: ref
    }));
  },
  createTextArea: props => {
    const {
        onChange,
        ref,
        attributes
      } = props,
      rest = __rest(props, ["onChange", "ref", "attributes"]);
    return jsxRuntime.jsx(Form__default["default"].Control, Object.assign({
      as: "textarea",
      onChange: e => {
        onChange === null || onChange === void 0 ? void 0 : onChange(e.target.value);
      }
    }, attributes, rest, {
      ref: ref
    }));
  },
  createCheckBox: props => {
    const {
      onChange,
      value,
      ref
    } = props;
    return jsxRuntime.jsx(Form__default["default"].Check, {
      ref: ref,
      onChange: e => {
        onChange === null || onChange === void 0 ? void 0 : onChange(e.target.checked);
      },
      checked: value === true
    });
  },
  createMenu: props => {
    var _a, _b, _c;
    const {
      options
    } = props;
    const cell = {
      rowIdentifier: ((_a = props.rowPosition) === null || _a === void 0 ? void 0 : _a.uniqueIdentifier) || "",
      columnIdentifier: ((_c = (_b = props.columnPosition) === null || _b === void 0 ? void 0 : _b.column) === null || _c === void 0 ? void 0 : _c.uniqueIdentifier) || ""
    };
    return jsxRuntime.jsx(ListGroup__default["default"], Object.assign({
      className: "flex-column"
    }, {
      children: options === null || options === void 0 ? void 0 : options.map((item, idx) => item ? jsxRuntime.jsx(ListGroup__default["default"].Item, Object.assign({
        onClick: () => item.onClick(cell)
      }, {
        children: item.label
      }), idx) : jsxRuntime.jsx(ListGroup__default["default"].Item, {}, idx))
    }), "menu");
  },
  createTriStateCheckbox: props => {
    return null;
  },
  createIconButton: (icon, {
    props
  }, textAndIcon) => {
    if (icon === gridCore.GridIconButton.PageFirst) {
      // return generateIcon(<FirstPage />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faFastBackward
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.PagePrevious) {
      // return generateIcon(<ArrowBack />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faArrowLeft
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.PageNext) {
      // return generateIcon(<ArrowForward />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faArrowRight
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.PageLast) {
      // return generateIcon(<LastPage />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faFastForward
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Settings) {
      // return generateIcon(<Settings />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faCog
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.SettingsSave) {
      // return generateIcon(<Save />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faSave
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.FilterBuilder) {
      // return generateIcon(<FilterList />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faFilter
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.ChartBuilder) {
      // return generateIcon(<Addchart />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faChartBar
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.SettingsManage) {
      // return generateIcon(<GridView />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faThLarge
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.ExpandOne) {
      // return generateIcon(<ExpandMore />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faChevronDown
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.ExpandAll) {
      // return generateIcon(<UnfoldMore />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faAngleDown
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.CollapseOne) {
      // return generateIcon(<ExpandLess />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faChevronUp
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.CollapseAll) {
      // return generateIcon(<UnfoldLess />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faAngleUp
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Pdf) {
      // return generateIcon(<PictureAsPdf />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faFilePdf
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Excel) {
      // return generateIcon(<FileDownload />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faDownload
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Cancel) {
      // return generateIcon(<Cancel />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faClose
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Reset) {
      // return generateIcon(<RestartAlt />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faSyncAlt
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Delete) {
      // return generateIcon(<DeleteOutline />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faTrashAlt
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Ok || icon === gridCore.GridIconButton.Apply) {
      // return generateIcon(<DoneOutline />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faCheck
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Filter) {
      // return generateIcon(<FilterAlt />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faFilterCircleDollar
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Edit) {
      // return generateIcon(<Edit />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faEdit
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Plus) {
      // return generateIcon(<AddCircle />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faPlus
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Minus) {
      // return generateIcon(<RemoveCircle />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faMinus
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Copy) {
      // return generateIcon(<CopyAll />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faCopy
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.Paste) {
      // return generateIcon(<ContentPaste />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faClipboard
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.FormulaColumn) {
      // return generateIcon(<AddRoad />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faBuildingColumns
      }), props, textAndIcon);
    } else if (icon === gridCore.GridIconButton.BulkEdit) {
      // return generateIcon(<EditRoad />, props, textAndIcon);
      return generateIcon(jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, {
        icon: freeSolidSvgIcons.faRoad
      }), props, textAndIcon);
    }
    return {
      props
    };
  }
};

exports.bootstrapAdapter = bootstrapAdapter;
exports.generateIcon = generateIcon;
